Prepare
=======

In this section, we will log into the Harvester environment through Rancher Manager.  We will prepare to launch Nextcloud by creating a namespace and uploading a boot image into it.

## Log in

To access the site for the demo, navigate to [https://rancher.lsit.ucsb.edu](https://rancher.lsit.ucsb.edu/dashboard/auth/login?local) in your browser.  First, before logging in, make sure the submit button says, "Log in with Local User".  If not, click "Use a local user" under the login button.

Use the following credentials to log in:

>User: demo
>
>Password: nextclouddemo

If you get a login error, make sure you are using a local and not OpenLDAP login and try again.

## Access Harvester

There are two ways to get there.  The first instructions will show how to get there through typical navigation.  The second will take you straight there with less clicks.

### Access it through Rancher navigation

On the lefthand side, locate the graphic that looks like 4 ship helms and [click on it](https://rancher.lsit.ucsb.edu/dashboard/c/_/harvesterManager/harvesterhci.io.management.cluster).

Here you will find the available Harvester Clusters for this user.  There's only one, so click on [compute-lsit](https://rancher.lsit.ucsb.edu/dashboard/harvester/c/c-m-fjm68t66/harvesterhci.io.dashboard).

### Access it directly.

Just [click here](https://rancher.lsit.ucsb.edu/dashboard/harvester/c/c-m-fjm68t66/harvesterhci.io.dashboard).

## Create a Namespace

As with Kubernetes, resources are grouped by Namespaces.  In addition, Rancher has the concept of Projects (distinct from OpenShift where project and namespace are synonymous) to group Namespaces, RBAC, resource quotas, etc.  In this tutorial, we'll create a Namespace that holds all of the resources of the Nextcloud deployment.

Note that there is also a special namespace called "Harvester-Public" which all users have access to.  This is an ideal place to store globally common VM images, but otherwise not wise to deploy to directly.

To create the namespace:

* Navigate to [Projects/Namespaces](https://rancher.lsit.ucsb.edu/dashboard/harvester/c/c-m-fjm68t66/projectsnamespaces)
* Click the [Create Namespace](https://rancher.lsit.ucsb.edu/dashboard/harvester/c/c-m-fjm68t66/namespace/create?projectId=p-2ljg2) button in the nextcloud-demo Project.
* In the name fieldi, give a polite and unique name to differentiate your demo from others
* Optionally set the description
* Note that you can set quota limits and labels for this project, but leave them alone for now.
* Click the Create button on the bottom right.

## Upload a VM image

Before we can create a VM, we need to upload one first.  Harvester can use any libvirt/qemu/Openstack style image in raw or qcow format or an installation iso.  You do *not* need to download the image first.  Harvester can download it directly from a link.  While you can certainly bring your own image at this point for another distribution/OS (eg, Fedora, Ubuntu, Debian, FreeBSD), the steps in this tutorial will reflect using OpenSUSE 15.6, so you'll need to translate any instructions accordingly if you choose something else and some features may not work if not enabled in the cloud image (console output, etc.).

Note that before you can upload an image, you must first create or otherwise have access to a namespace.  If you have not done so, go back and create a namespace from the previous section.

* Navigate to [Images](https://rancher.lsit.ucsb.edu/dashboard/harvester/c/c-m-fjm68t66/harvesterhci.io.virtualmachineimage) on the left-hand side.
* Click the blue [Create button](https://rancher.lsit.ucsb.edu/dashboard/harvester/c/c-m-fjm68t66/harvesterhci.io.virtualmachineimage/create) on the top right
* Select the namespace you created in the previous step.
* Name the image: OpenSUSE-Leap-15.6
* In Basics, leave the radio button as URL and in the URL field, paste this link: `https://download.opensuse.org/repositories/Cloud:/Images:/Leap_15.6/images/openSUSE-Leap-15.6.x86_64-NoCloud.qcow2`
* In Labels, note that the image-type and OS have already been detected and prefilled.

### A note about images

Images in the harvester-public namespace are available to all users in the cluster.  Should you have difficulty with this step or don't want to wait for the download, please instead use the [opensuse-leap-15.6](https://rancher.lsit.ucsb.edu/dashboard/harvester/c/c-m-fjm68t66/harvesterhci.io.virtualmachineimage/harvester-public/image-kv26l#detail) image from the harvester-public namespace to deploy your VM in the next section.


Next step: [Launch a VM](https://git.lsit.ucsb.edu/scottwilliams/nextcloud-harvester-demo/src/branch/main/02-launch-vm)